import java.io.*;
import java.util.Vector;


public class codehtml2{
	
	StringBuffer sb;
	BufferedWriter bw;
	BufferedReader br;
	String filename;
	Vector<String> type1,type2,type3;
	
	static final String endtag = " /?.><,'"  + "\""   + ";:\\|][}{+=-()*&^%$#@!~\n\t\r";
	static final boolean replacetabs = true;
	
	public codehtml2(String filename){
		this.filename=filename;
		try{
			br=new BufferedReader(new InputStreamReader(new FileInputStream(filename)));
			bw=new BufferedWriter(new OutputStreamWriter(new FileOutputStream(filename+".html")));
			sb=new StringBuffer("");
		}catch(IOException e){
			System.out.println("Error:\n\t"+e.getMessage());
		}
		type1=new Vector<String>();
		type2=new Vector<String>();
		type3=new Vector<String>();
		
		loaddictionary();
	}
	
	public void loaddictionary(){
		try{
			
			//TYPE 1 MODIFIERS
			BufferedReader br = new BufferedReader(new InputStreamReader(new FileInputStream("rule1.txt")));
			String s="";
			while( (s=br.readLine()) != null){
				type1.add(s);
			}

			//TYPE 2 MODIFIERS
			br = new BufferedReader(new InputStreamReader(new FileInputStream("rule2.txt")));
			while( (s=br.readLine()) != null){
				type2.add(s);
			}
			
			//TYPE 3 MODIFIERS
			br = new BufferedReader(new InputStreamReader(new FileInputStream("rule3.txt")));
			while( (s=br.readLine()) != null){
				type3.add(s);
			}
			br.close();
		}catch(IOException e){
			System.out.println("Error:"+e);
		}
		

	}
		
	public void parse() throws IOException{
		int in=0;
		char ch;
		String temp="";
		while( (in=br.read()) != -1){
			ch = (char)in;
			if(ch == '/'){
				in = br.read();
				if(in == -1)return;
				else ch = (char)in;
				
				if(ch == '*'){
					//start multiline comment.
					bw.write("<font color=\"green\">/*");
					char chp = '*';
					while(true){
						chp = ch;
						in = br.read();
						if(in == -1)break;
						ch = (char)in;
						bwwrite(ch);
						if(chp == '*' && ch == '/')break;
					}
					bw.write("</font>");
					continue;
				}
				else if(ch == '/'){
					//start single line comment.
					bw.write("<font color=\"green\">//");
					while(true){
						in = br.read();
						if(in == -1)break;
						ch = (char)in;
						bwwrite(ch);
						if(ch == '\r' || ch == '\n')break;
					}
					bw.write("</font>");
					continue;
				}
				else {
					bw.write('/');
					bwwrite(ch);
					continue;
				}
			}
			if(ch == '\t' && replacetabs){
				bw.write("    ");
				continue;
			}	
			else if( (endtag.indexOf(ch))==-1){
				sb.append(ch);
				continue;
			}
			else{
				temp=sb.toString();
				
				
				if(type1.contains(temp)){
					bw.write("<font color=blue>"+temp+"</font>");
				}
				
				else if(type2.contains(temp)){
					bw.write("<font color=red>"+temp+"</font>");
				}
				
				else if(type3.contains(temp)){
					bw.write("<font color=\"#ff00ff\">"+temp+"</font>");
				}
				
				else bwwrite(sb.toString());
				sb.delete(0,sb.length());
				bwwrite(ch);
			}
			//bw.write(ch);
		}
		bw.write(sb.toString());
	}
	
	public void writeheader() throws IOException{
		bw.write("<html>");
		bw.write("<head>");
		bw.write("<title>Code: "+filename+"</title>");
		bw.write("</head>");
		bw.write("<body>");
		bw.write("<p>");
		bw.write("<pre>");
	}
	
	public void writefooter() throws IOException{
		bw.write("</pre>");
		bw.write("<p><hr>");
		bw.write("<font face=\"Verdana\" size=1>Made by code2Html ver 0.0.3, &copy;2004, Sushovan De</font>");
		bw.write("</body>");
		bw.write("</html>");
	}
			
	public void cleanup() throws IOException{
		bw.flush();
		bw.close();
		br.close();
	}
	
	private void bwwrite(char ch) throws IOException{
		if(ch == '<')bw.write("&lt;");
		else if(ch == '\t' && replacetabs)bw.write("    ");
		else bw.write(ch);
	}
	
	private void bwwrite(String s) throws IOException{
		bw.write(s.replace("<","&lt;").replace("\t","    "));
	}
	

			
			
	public static void main(String args[]){
		codehtml2 c =new codehtml2("filename.java");
		try{
			c.writeheader();
			c.parse();
			c.writefooter();
			c.cleanup();
		}catch(IOException e){System.out.println("Exception"+e);}		
	}
}